#ifndef OPERATORS_H
#define OPERATORS_H 1

#include "densematrix.h"
#include <vector>

/* This header contains Matrix-Vector and Vector-Vector operations
 * for the matrix types
 *  - DenseMatrix
 *  - SparseMatrix
 * and the vector types
 *  - std::vector<double>
 */

//=====================================
// Operators for std::vector<double>
//=====================================

/* Operator v = v1 - v2 */
std::vector<double>
operator-(const std::vector<double> &v1, const std::vector<double> &v2){
    std::vector<double> ret(v1.size());
    for(size_t i = 0; i < v1.size(); ++i){
        ret[i] = v1[i] - v2[i];
    }
    return ret;
}


/* Operator v = A*v (A matrix, v vector) */
std::vector<double>
operator*(const DenseMatrix &m, const std::vector<double> &v){
    //=======//
    // TODO  //
    //=======//
}


/* Operator v = v1 + v2 */
std::vector<double>
operator+(const std::vector<double> &v1, const std::vector<double> &v2){
    //=======//
    // TODO  //
    //=======//
}


/* Operator v = a * v1 (a scalar)*/
std::vector<double>
operator*(const double scalar, const std::vector<double> &v){
    //=======//
    // TODO  //
    //=======//
}

/* Operator a = v1 * v2 */
double
operator*(const std::vector<double> &v1, const std::vector<double> &v2){
    //=======//
    // TODO  //
    //=======//
}

/* Output Operator*/
std::ostream& 
operator<< (std::ostream& out, const std::vector<double> & v){
    for(size_t i = 0; i < v.size(); ++i){
        out << v[i] << std::endl;
    }
    
    return out;
}

#endif //OPERATORS_H